package netscape.netcast.application;

import java.applet.Applet;
import java.util.StringTokenizer;
import java.util.Vector;
import netscape.javascript.JSObject;

public final class NCPrefsManager extends Thread {
   private static Applet applet = null;
   private static JSObject jsContext;
   private CategoryData threadChannelType;
   static String m_defaultChannelName;
   static final String PREF_CHANNEL_BASE = "netcaster.containers.container";
   static final String PREF_CONTAINER_COUNT = "netcaster.containers.count";
   static final String GET_PREF_FUNCTION_STR = "getNavigatorPrefStr";
   static final String SET_PREF_FUNCTION_STR = "setNavigatorPrefStr";
   static final String DEL_PREF_FUNCTION = "delNavigatorPref";

   public static void Initialize(Applet var0) {
      applet = var0;
      jsContext = JSObject.getWindow(var0);
   }

   public static CategoryData LoadChannelList() {
      String[] var1 = new String[]{""};
      String var7 = "";
      String var8 = "";
      String var9 = "";
      String var10 = "";
      if (applet == null) {
         throw new IllegalStateException("Preferences not initialized");
      } else {
         m_defaultChannelName = GetData("netcaster.defaultChannel", "");
         var1[0] = "netcaster.containers.count";
         String var0 = (String)jsContext.call("getNavigatorPrefStr", var1);
         int var5;
         if (var0 != null && var0.equals("undefined")) {
            var5 = 0;
         } else if (var0 != null) {
            var5 = Integer.parseInt(var0);
         } else {
            var5 = 0;
         }

         CategoryData var4 = new CategoryData(applet, "Top_Level");

         for(int var6 = 1; var6 <= var5; ++var6) {
            var0 = GetData("netcaster.containers.container_" + String.valueOf(var6), "");
            if (var0.length() != 0) {
               StringTokenizer var2 = new StringTokenizer(var0, ";");
               if (var2.hasMoreElements()) {
                  var7 = var2.nextToken();
               } else {
                  var7 = "";
               }

               if (!var2.hasMoreElements()) {
                  var8 = "";
               } else {
                  var8 = var2.nextToken("\t\n\r;");
                  if (var8.startsWith("'") && var8.endsWith("'") || var8.startsWith("\"") && var8.endsWith("\"")) {
                     var8 = var8.substring(1, var8.length() - 1);
                  }
               }

               if (var2.hasMoreElements()) {
                  var10 = var2.nextToken(";");
               } else {
                  var10 = var8;
               }

               if (var2.hasMoreElements()) {
                  var9 = var2.nextToken(";");
               } else {
                  var9 = "";
               }

               CategoryData var3 = new CategoryData(applet, var8, var10);
               var3.LoadData(var7, var9);
               var4.addItem(var3, true);
               var3.LoadItems();
            }
         }

         return var4;
      }
   }

   public static void SaveChannelList(CategoryData var0, boolean var1) {
      String[] var2 = new String[]{"", ""};
      if (applet == null) {
         throw new IllegalStateException("Preferences not initialized");
      } else {
         int var3 = var0.size();
         var2[0] = "netcaster.containers.count";
         var2[1] = "" + var3;
         jsContext.call("setNavigatorPrefStr", var2);

         for(int var4 = 0; var4 < var3; ++var4) {
            Vector var5 = var0.getVector();
            var2[0] = "netcaster.containers.container" + String.valueOf(var4 + 1);
            var2[1] = ((CategoryData)var5.elementAt(var4)).keyString();
            jsContext.call("setNavigatorPrefStr", var2);
            ((CategoryData)var5.elementAt(var4)).Save(var1);
         }

      }
   }

   public static void writePrefs() {
      jsContext.eval("navigator.savePreferences();");
   }

   public static void GetChannelsOfType(String var0, CategoryData var1) {
      String[] var2 = new String[]{""};
      if (applet == null) {
         throw new IllegalStateException("Preferences not initialized");
      } else {
         var2[0] = "netcaster." + var0 + ".count";
         String var3 = (String)jsContext.call("getNavigatorPrefStr", var2);
         int var4;
         if (var3 != null && var3.equals("undefined")) {
            var4 = 0;
         } else {
            var4 = Integer.parseInt(var3);
         }

         for(int var5 = 1; var5 <= var4; ++var5) {
            var2[0] = "netcaster." + var0 + "." + var0 + "_" + var5;
            var3 = (String)jsContext.call("getNavigatorPrefStr", var2);
            if (var3 != null && var3.equals("undefined")) {
               boolean var13 = true;
            } else {
               boolean var10000 = false;
            }

            String var7 = "netcaster." + var0 + "." + var3 + ".";
            var2[0] = var7 + "type";
            var3 = (String)jsContext.call("getNavigatorPrefStr", var2);
            Integer var8;
            if (var3 != null && var3.equals("undefined")) {
               var8 = new Integer(0);
            } else {
               var8 = new Integer(0);

               try {
                  if (var3 != null) {
                     var8 = new Integer(var3);
                  }
               } catch (NumberFormatException var10) {
                  ((Throwable)var10).printStackTrace();
               }
            }

            Object var6;
            if (var8 == 2) {
               var6 = new CastanetDataItem(applet, var7);
            } else {
               var6 = new SiteData(applet, var7);
            }

            var1.addItem((DataItem)var6, true);
         }

      }
   }

   public static String GetData(String var0, String var1) {
      String[] var3 = new String[]{""};
      if (applet == null) {
         throw new IllegalStateException("Preferences not initialized");
      } else {
         var3[0] = var0;
         String var2 = (String)jsContext.call("getNavigatorPrefStr", var3);
         if (var2 == null || var2.equals("undefined")) {
            var2 = var1;
         }

         return var2;
      }
   }

   public static Boolean GetData(String var0, Boolean var1) {
      String[] var3 = new String[]{""};
      if (applet == null) {
         throw new IllegalStateException("Preferences not initialized");
      } else {
         var3[0] = var0;
         Boolean var2 = (Boolean)jsContext.call("getNavigatorPrefStr", var3);
         if (var2 == null) {
            ;
         }

         return var1;
      }
   }

   public static void GetBatchData(String[] var0, String[] var1) {
      Object[] var2 = new Object[2];
      if (applet == null) {
         throw new IllegalStateException("Preferences not initialized");
      } else {
         var2[0] = var0;
         var2[1] = var1;
         jsContext.call("getNavigatorBatchPrefs", var2);
      }
   }

   public static void SetBatchData(String[] var0, String[] var1) {
      Object[] var2 = new Object[2];
      if (applet == null) {
         throw new IllegalStateException("Preferences not initialized");
      } else {
         var2[0] = var0;
         var2[1] = var1;
         jsContext.call("setNavigatorBatchPrefs", var2);
      }
   }

   public static void SaveData(String var0, String var1) {
      String[] var2 = new String[]{"", ""};
      if (applet == null) {
         throw new IllegalStateException("Preferences not initialized");
      } else {
         var2[0] = var0;
         var2[1] = var1;
         jsContext.call("setNavigatorPrefStr", var2);
      }
   }

   public static void SaveData(String var0, Boolean var1) {
      String[] var2 = new String[]{"", ""};
      if (applet == null) {
         throw new IllegalStateException("Preferences not initialized");
      } else {
         var2[0] = var0;
         var2[1] = var1.toString();
         jsContext.call("setNavigatorPrefStr", var2);
      }
   }

   public static void DelPref(String var0) {
      String[] var1 = new String[]{""};
      if (var0 != null) {
         if (applet == null) {
            throw new IllegalStateException("Preferences not initialized");
         } else {
            var1[0] = var0;
            jsContext.call("delNavigatorPref", var1);
         }
      }
   }

   public static SiteData getSiteData(Applet var0, String var1) {
      SiteData var2 = new SiteData(var0, var1);
      var2.added((CategoryData)null, true);
      return var2;
   }

   public synchronized void threadedSaveChannelList(CategoryData var1) {
      ((Thread)this).setPriority(1);
      this.threadChannelType = var1;
      ((Thread)this).start();
   }

   public void run() {
      SaveChannelList(this.threadChannelType, false);
   }
}
